#include <bits/stdc++.h>

using namespace std;

struct Point {
    long long p, val, dk, dk2;
};

long long dfs(vector <vector <long long>>& graf, vector <Point>& s, vector <bool>& used, long long i, long long p, long long val) {
    used[i] = true;
    s[i].p = p;
    s[i].val = val;
    s[i].dk = 0;
    s[i].dk2 = 0;
    for (long long j = 0; j < graf[i].size(); j++) {
        if (used[graf[i][j]] == false) {
            long long val = dfs(graf, s, used, graf[i][j], i, val + 1);
            if (val > s[i].dk) {
                s[i].dk2 = s[i].dk;
                s[i].dk = val;
            } else if (val > s[i].dk2) {
                s[i].dk2 = val;
            }
        }
    }
    return s[i].val;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    long long n, k, t, u, v;
    cin >> n >> k >> t;
    vector <vector <long long>> graf(n);
    vector <Point> s(n, {0, 0, 0});
    vector <bool> used(n, false), used2(n, false);
    for (long long i = 0; i < n - 1; i++) {
        cin >> u >> v;
        graf[u - 1].push_back(v - 1);
        graf[v - 1].push_back(u - 1);
    }
    dfs(graf, s, used2, 0, 0, 0);
    if (t == 0) {
        if (k == 1) {
            long long ans = 1e18;
            for (long long i = 1; i < n; i++) {
                long long now = (s[i].dk - s[i].val) + 1;
                if (s[0].dk == s[0].dk2 || s[0].dk > s[i].dk) {
                    ans = min(ans, s[0].dk);
                } else {
                    ans = min(ans, max(s[0].dk2, now));
                }
            }
            cout << ans;
        } else {
            if (k >= (n - 2)) {
                cout << 1 << endl;
            } else {
                long long nn = (n - 1) - (k + 1);
                if (nn % (k + 1) == 0) {
                    cout << nn / (k + 1) + 1;
                } else {
                    cout << nn / (k + 1) + 2;
                }
            }                                           
        }
    }
    return 0;
}